using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.ExcelRW;
namespace EssentialXlsIOSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(88, 32);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "Create XLS";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(264, 86);
			this.Controls.Add(this.button1);
			this.Name = "Form1";
			this.Text = "Essential XlsIO Samples";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//New instance of XlsIO is created.[Equivalent to launching MS Excel with no workbooks open].
			//The instantiation process consists of two steps.

			//Step 1 : Instantiate the spreadsheet creation engine.
			ExcelEngine excelEngine = new ExcelEngine();
			//Step 2 : Instantiate the excel application object.
			IApplication application = excelEngine.Excel;

			//A new workbook is created.[Equivalent to creating a new workbook in MS Excel]
			//The new workbook will have 3 worksheets
			IWorkbook workbook = excelEngine.Excel.Workbooks.Open(@"..\..\Template\FormattedTemplate.xls"); 
			//The first worksheet object in the worksheets collection is accessed.
			IWorksheet sheet = workbook.Worksheets[0];
            
			// Setting Font Type
			sheet.Range["A2"].CellStyle.Font.FontName = "Arial Black";
			sheet.Range["A4"].CellStyle.Font.FontName = "Castellar";
            // Setting Font Styles
			sheet.Range["A6"].CellStyle.Font.Bold = true;
			sheet.Range["A8"].CellStyle.Font.Italic = true;
            // Setting Font Size
			sheet.Range[ "A10" ].CellStyle.Font.Size = 18;
            // Setting Font Effects
			sheet.Range["A12"].CellStyle.Font.Strikethrough = true;
			sheet.Range["B10"].CellStyle.Font.Subscript = true;
			sheet.Range["B12"].CellStyle.Font.Superscript = true;
            // Setting UnderLine Types
			sheet.Range["B2"].CellStyle.Font.Underline = ExcelUnderline.Double;
			sheet.Range["B4"].CellStyle.Font.Underline = ExcelUnderline.DoubleAccounting;
			sheet.Range["B6"].CellStyle.Font.Underline = ExcelUnderline.Single;
			sheet.Range["B8"].CellStyle.Font.Underline = ExcelUnderline.SingleAccounting;
            // Setting Font Color
			sheet.Range["C2"].CellStyle.Font.Color = ExcelKnownColors.Lavender;
			sheet.Range["C4"].CellStyle.Font.Color = ExcelKnownColors.Light_blue;
			sheet.Range["C6"].CellStyle.Font.Color = ExcelKnownColors.Indigo;
            
			// Clearing the Range values and not the Formattings
			sheet.Range["A1:C12"].Clear();

            //Saving the workbook to disk.
			workbook.SaveAs("Sample.xls");

			//Close the workbook.
			workbook.Close();

			//No exception will be thrown if there are unsaved workbooks.
			excelEngine.ThrowNotSavedOnDestroy = false;
			excelEngine.Dispose(); 

			//Message box confirmation to view the created spreadsheet.
			if (MessageBox.Show ("Do you want to view the workbook?", "Workbook has been created",
				MessageBoxButtons.YesNo, MessageBoxIcon.Information)
				== DialogResult.Yes) 
			{
				//Launching the Excel file using the default Application.[MS Excel Or Free ExcelViewer]
				System.Diagnostics.Process.Start("Sample.xls");
				//Exit
				this.Close();
			}
			else
			{
				// Exit
				this.Close();
			}
		
		}
	}
}
